//+------------------------------------------------------------------+
//|                                             DemoPolymorphism.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Classe base da forma do objeto                                   |
//+------------------------------------------------------------------+
class CShape
  {
private:
   int               m_type;
public:
                     CShape(){m_type=0;}
   void              Draw();
   string            getTypeName(){return("Forma");}
  };
//+------------------------------------------------------------------+
//| A classe  do objeto linha                                        |
//+------------------------------------------------------------------+
class CLine:public CShape
  {
private:
   int               m_type;
public:
                     CLine(){m_type=1;}
   void              Draw();
   string            getTypeName(){return("Linha");}
  };
//+------------------------------------------------------------------+
//| A classe do objeto tringulo                                     |
//+------------------------------------------------------------------+
class CTriangle:public CShape
  {
private:
   int               m_type;
public:
                     CTriangle(){m_type=2;}
   void              Draw();
   string            getTypeName(){return("Tringulo");}
  };
//+------------------------------------------------------------------+
//| A classe do objeto retngulo                                     |
//+------------------------------------------------------------------+
class CRectangle:public CShape
  {
private:
   int               m_type;
public:
                     CRectangle(){m_type=3;}
   void              Draw();
   string            getTypeName(){return("Retngulo");}
  };
//+------------------------------------------------------------------+
//| A classe do objeto crculo                                       |
//+------------------------------------------------------------------+
class CCircle:public CShape
  {
private:
   int               m_type;
public:
                     CCircle(){m_type=4;}
   void              Draw();
   string            getTypeName(){return("Crculo");}
  };
//+------------------------------------------------------------------+
//| Funo incio do Script                                          |
//+------------------------------------------------------------------+
void OnStart()
  {
//--- um array de ponteiros de objetos do tipo CShape
   CShape *shapes[];
//--- redimensionamento de um array 
   ArrayResize(shapes,5);
//--- Preenchendo os ponteiros do array
   shapes[0]=new CShape;
   shapes[1]=new CLine;
   shapes[2]=new CTriangle;
   shapes[3]=new CRectangle;
   shapes[4]=new CCircle;
//--- imprimindo o tipo de cada elemento do array
   for(int i=0;i<5;i++)
     {
      Print(i,shapes[i].getTypeName());
     }
//--- excluindo todos os objetos do array
   for(int i=0;i<5;i++) delete(shapes[i]);
  }
//+------------------------------------------------------------------+
